//---------------------------------------------------
//  可変フィルタで使う縦続形 IIR フィルタ
//
//  2022/12/22, Copyright (c) 2022 MIKAMI, Naoki
//---------------------------------------------------

#include "BiquadV.hpp"
#include "Array.hpp"    // Array クラスが定義されている

#ifndef IIR_CASCADEV_HPP
#define IIR_CASCADEV_HPP

namespace Mikami
{
    class IirCascadeV
    {
    public:
        // コンストラクタ
        IirCascadeV(int order = 0, const BiquadV hk[] = NULL, float g0 = 1)
            : order_(order), hn_((order+1)/2, hk), g0_(g0) {}

        // フィルタ処理を実行する
        float Execute(float xn)
        {
            float yn = g0_*xn;
            for (int k=0; k<(order_+1)/2; k++) yn = hn_[k].Execute(yn);
            return yn;
        }

        // 係数の設定
        void SetCoefs(int order, const BiquadV::Coefs ck[], float g0)
        {
            if (order_ != order)
            {
                order_ = order;
                hn_.SetSize((order+1)/2);
            }
            g0_ = g0;
            for (int k=0; k<(order+1)/2; k++) hn_[k].SetCoefs(ck[k]);
        }

        // 内部変数（単位遅延素子）のクリア
        void Clear()
        {   for (int k=0; k<(order_+1)/2; k++) hn_[k].Clear(); }

    private:
        int order_;         // 次数
        Array<BiquadV> hn_; // BiquadV クラスのオブジェクトの配列
        float g0_;          // 利得定数
    };
}
#endif  // IIR_CASCADEV_HPP
